VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cfLiqPlan"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private WithEvents mfLiqPlan As cWidgetForm       'Presenter
Attribute mfLiqPlan.VB_VarHelpID = -1
Private WithEvents fLiqKat As cfLiqKat
Attribute fLiqKat.VB_VarHelpID = -1
Private WithEvents mWV As cWebView2               'Browser
Attribute mWV.VB_VarHelpID = -1
Private mLiqPlan As cmLiqPlan                     'Daten
Private mFileName As String                       'Datei
Private mLoadTemplateComplete As Boolean
Private Enum sumMode
    smAlle = 0
    smEin = 1
    smAus = 2
End Enum
Private mOptionSum As sumMode


Private Sub Class_Initialize()
    On Error Resume Next
    Set mfLiqPlan = Cairo.WidgetForms.Create(Caption:="Liquidittsplaner")
    mfLiqPlan.IconImageKey = "progIcn" 'Fenster-Icon
End Sub

Public Function Show() As Boolean
Dim file As String
Dim w As Long, h As Long
    On Error GoTo Show_Error
    w = GetSetting(App.ProductName, "Settings", "Width", 1280)
    h = GetSetting(App.ProductName, "Settings", "Height", 720)
    Set mWV = WinHelper.BindWebView(mfLiqPlan)                      'Browser anbinden
    With mfLiqPlan
        .Width = w
        .Height = h
        .CenterOn New_c.Displays.Primary
        .Show
    End With
    
    If Not mWV Is Nothing Then
        file = GetSetting(App.ProductName, "Settings", "LastFile", "")  'letzte Datei suchen
        If Not New_c.fso.FileExists(file) Then file = ""
        If Len(file) = 0 Then
            Call newFile                                                'Start mit neuer Datei
        Else
            Call openFile(file)                                         'Start mit letzter Datei
        End If
        Show = True
    End If

    Exit Function
    
Show_Error:
    Err.Raise Err.Number, _
     "cfLiqPlan.Show." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function


Private Sub fLiqKat_DialogAction(action As String)
    On Error GoTo fLiqKat_DialogAction_Error
    mfLiqPlan.Enabled = True
    Set fLiqKat = Nothing
    loadTemplate "liqplan.html"
    mWV.jsRun "FillData", mLiqPlan.GetJSONKat, mLiqPlan.GetJSONPlan, mOptionSum
    Exit Sub
    
fLiqKat_DialogAction_Error:
    Screen.MousePointer = vbDefault
    MsgBox "Fehler: " & Err.Number & vbCrLf & _
     "Beschreibung: " & Err.Description & vbCrLf & _
     "Quelle: cfLiqPlan.fLiqKat_DialogAction." & Erl & vbCrLf & Err.Source, _
     vbCritical
End Sub

Private Sub mWV_AcceleratorKeyPressed(ByVal KeyState As RC6.eWebView2AccKeyState, ByVal IsExtendedKey As Boolean, ByVal WasKeyDown As Boolean, ByVal IsKeyReleased As Boolean, ByVal IsMenuKeyDown As Boolean, ByVal RepeatCount As Long, ByVal ScanCode As Long, IsHandled As Boolean)
Const wvKeyF5 As Long = 63
    If ScanCode = wvKeyF5 Then
        If App.LogMode Then IsHandled = True
    End If
End Sub

Private Sub mWV_DocumentComplete()
    On Error Resume Next
    mWV.jsRun "Init"
    mLoadTemplateComplete = True
End Sub

Private Sub newFile()
    On Error GoTo newFile_Error
    loadTemplate "liqplan.html"
    Set mLiqPlan = New cmLiqPlan
    mLiqPlan.NewLiqPlan
    FileName = ""
    mOptionSum = sumMode.smAlle
    mWV.jsRun "FillData", mLiqPlan.GetJSONKat, mLiqPlan.GetJSONPlan, mOptionSum
    Exit Sub
    
newFile_Error:
    Err.Raise Err.Number, _
     "cfLiqPlan.newFile." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Sub


Private Sub openFile(Optional file As String)
Dim fso As cFSO
Dim Filter As String, defFolder As String
    On Error GoTo openFile_Error
    Set fso = New_c.fso
    If Len(file) = 0 Then
        If Len(mFileName) Then
            defFolder = fso.GetPathNameFromFullPath(mFileName)
        Else
            defFolder = GetSetting(App.ProductName, "Settings", "AppData", "")
            If Len(defFolder) = 0 Then defFolder = fso.GetLocalAppDataPath & "\" & App.ProductName
            If Not fso.FolderExists(defFolder) Then defFolder = fso.GetLocalAppDataPath
        End If
        Filter = "Liquidittsplaner (*.lp)|*.lp"
        file = fso.ShowOpenDialog(OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST, defFolder, "Liquidittsplaner ffnen...", , Filter, "lp", mfLiqPlan.hwnd)
        If Len(file) = 0 Then Exit Sub
    End If
    
    loadTemplate "liqplan.html"
    Set mLiqPlan = New cmLiqPlan
    If mLiqPlan.OpenPlan(file) Then
        mWV.jsRun "FillData", mLiqPlan.GetJSONKat, mLiqPlan.GetJSONPlan, mOptionSum
        SaveSetting App.ProductName, "Settings", "LastFile", file
        SaveSetting App.ProductName, "Settings", "AppData", fso.GetPathNameFromFullPath(file)
        FileName = file
    End If

RESUME_OPEN:
    Exit Sub
    
openFile_Error:
    Err.Raise Err.Number, "cfLiqPlan.openFile." & Erl & vbCrLf & Err.Source, Err.Description
End Sub

Private Function saveFile(Optional SaveAs As Boolean) As Boolean
Dim fso As cFSO
Dim Filter As String, file As String, defFolder As String

    On Error GoTo saveFile_Error
    Set fso = New_c.fso
    If Len(mFileName) > 0 Then file = mFileName
    If Len(mFileName) = 0 Or SaveAs Then
        If App.LogMode = 0 Then
            defFolder = AppPath   'IDE
        Else
            defFolder = GetSetting(App.ProductName, "Settings", "AppData", "")
            If Len(defFolder) = 0 Then defFolder = fso.GetLocalAppDataPath & "\" & App.ProductName
            If Not fso.FolderExists(defFolder) Then defFolder = fso.GetLocalAppDataPath
        End If
        Filter = "Liquidittsplaner (*.lp)|*.lp"
        file = fso.ShowSaveDialog(OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST, defFolder, "Liquidittsplaner speichern...", file, Filter, "lp", mfLiqPlan.hwnd)
        If Len(file) = 0 Then Exit Function
        If Right$(LCase$(file), 3) <> ".lp" Then file = file & ".lp"
        If fso.FileExists(file) Then
            If MsgBox("Die Datei " & vbCrLf & file & vbCrLf & "existiert bereits. Mchten Sie diese Datei berschreiben?", _
                    vbQuestion + vbYesNo, "Speichern") = vbNo Then Exit Function
        End If
    End If
          
    If Len(file) = 0 Then Exit Function
    With fso
        If mLiqPlan.Save(file) Then
            SaveSetting App.ProductName, "Settings", "LastFile", file
            SaveSetting App.ProductName, "Settings", "AppData", .GetPathNameFromFullPath(file)
            FileName = file
            saveFile = True
        End If
    End With
    
    Exit Function
    
saveFile_Error:
    Err.Raise Err.Number, "cfLiqPlan.saveFile." & Erl & vbCrLf & Err.Source, Err.Description
End Function



Private Function checkForChangedData() As Boolean
    On Error GoTo checkForChangedData_Error
    If mLiqPlan.DataChanged Then
        Select Case MsgBox("Der aktuelle Liquidittsplan enthllt nderungen, die noch nicht gespeichert sind. Mchten Sie diese nderungen jetzt speichern?", vbQuestion + vbYesNoCancel, "Speichern...")
            Case vbYes:     If Not saveFile Then Exit Function
            Case vbCancel:  Exit Function
        End Select
    End If
    checkForChangedData = True
    Exit Function
    
checkForChangedData_Error:
    Err.Raise Err.Number, _
     "cfLiqPlan.checkForChangedData." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Private Function loadTemplate(tplFileName As String) As Boolean
    On Error GoTo loadTemplate_Error
    mLoadTemplateComplete = False
    If HtmlHelper.ReadFromRes Then
        mWV.Navigate "file:///" & Replace(AppPath, "\", "/") & "/Res/" & tplFileName
    Else
        mWV.NavigateToString HtmlHelper.Crypt.UTF8ToVBString(HtmlHelper.AppRes.GetContent(tplFileName))
    End If
    Do Until mLoadTemplateComplete
        DoEvents
    Loop
    loadTemplate = True
    Exit Function
    
loadTemplate_Error:
    Err.Raise Err.Number, _
     "cfLiqPlan.loadTemplate." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Private Sub mfLiqPlan_GotFocus()
    On Error Resume Next
    If Not mWV Is Nothing Then mWV.SetFocus
End Sub

Private Sub mfLiqPlan_Resize()
    If mfLiqPlan.WindowState <> vbMinimized Then
        If Not mWV Is Nothing Then mWV.SyncSizeToHostWindow
    End If
End Sub

Private Sub mfLiqPlan_QueryUnload(Cancel As Boolean, UnloadMode As QueryUnloadConstants)
    On Error Resume Next
    If checkForChangedData Then
        SaveSetting App.ProductName, "Settings", "Width", mfLiqPlan.Width
        SaveSetting App.ProductName, "Settings", "Height", mfLiqPlan.Height
    Else
        Cancel = True
    End If
End Sub

Private Sub mfLiqPlan_Unload(Cancel As Integer)
    On Error Resume Next
    Set fLiqKat = Nothing
    If App.LogMode = 0 Then Unload fDummy
End Sub

Private Property Get FileName() As String
    FileName = mFileName
End Property

Private Property Let FileName(ByVal vNewValue As String)
    On Error Resume Next
    mFileName = vNewValue
    If Len(vNewValue) = 0 Then
        mfLiqPlan.Caption = "Liquidittsplaner "
    Else
        mfLiqPlan.Caption = "Liquidittsplaner " & " - " & Left$(mFileName, InStr(3, mFileName, "\")) & "...\" & New_c.fso.GetFileNameFromFullPath(mFileName)
    End If
End Property


Private Sub mWV_JSMessage(ByVal sMsg As String, ByVal sMsgContent As String, oJSONContent As RC6.cCollection)
Dim id As Long
Dim value As Currency
Dim s As String
    On Error GoTo mWV_JSMessage_Error
    Select Case True
        Case sMsg Like "change::txtBez*"
            s = Mid$(sMsg, 15)
            If IsNumeric(s) Then
                id = CLng(s)
                mLiqPlan.UpdateBezeichnung id:=id, Bezeichnung:=sMsgContent
            End If
            
        Case sMsg Like "change::selKat*"
            s = Mid$(sMsg, 15)
            If IsNumeric(s) Then
                id = CLng(s)
                mLiqPlan.UpdateKat id:=id, Kat:=CLng(sMsgContent)
            End If
            
        Case sMsg Like "change::txtPos*"
            s = Mid$(sMsg, 15)
            id = CLng(Val(s))
            s = Mid$(s, InStr(1, s, "m"))
            If IsNumeric(sMsgContent) Then value = CCur(sMsgContent)
            value = mLiqPlan.UpdateData(id:=id, col:=s, value:=value)
            mWV.jsRun "UpdateData", id, Str$(value), mLiqPlan.GetJSONSum()
            
        Case sMsg Like "change::rd*"
            mOptionSum = CInt(sMsgContent)
            
        Case sMsg = "click"
            Select Case True
                Case sMsgContent = "mnuRef", sMsgContent = "mnuCloseAusw"
                    loadTemplate "liqplan.html"
                    mWV.jsRun "FillData", mLiqPlan.GetJSONKat, mLiqPlan.GetJSONPlan, mOptionSum
                    
                Case sMsgContent = "mnuNew"
                    If checkForChangedData Then Call newFile
                    
                Case sMsgContent = "mnuOpen"
                    If checkForChangedData Then Call openFile
                    
                Case sMsgContent = "mnuSave"
                    Call saveFile
                    
                Case sMsgContent = "mnuSaveAs"
                    Call saveFile(True)
                    
                Case sMsgContent Like "mnuPrint*"
                    mWV.ExecuteScript "window.print()"
                    
                Case sMsgContent = "mnuOpt"
                    Set fLiqKat = New cfLiqKat
                    fLiqKat.Show mfLiqPlan, mLiqPlan
                    mfLiqPlan.Enabled = False
                    
                Case sMsgContent = "mnuAusw", sMsgContent = "mnuRefAusw"
                    loadTemplate "liqausw.html"
                    mWV.jsRun "FillData", mLiqPlan.GetJSONKatValues
                    
                Case sMsgContent = "mnuClose"
                    mfLiqPlan.Unload
                    
                Case sMsgContent = "addPosten"
                    id = mLiqPlan.AddPosten
                    If id > 0 Then mWV.jsRun "AddPosten", id
                    
                Case sMsgContent Like "delPosten*"
                    id = CLng(Mid$(sMsgContent, 10))
                    If mLiqPlan.DelPosten(id) Then
                        mWV.jsRun "DelPosten", id, mLiqPlan.GetJSONSum()
                    End If
            End Select
    End Select
        
    Exit Sub
        
mWV_JSMessage_Error:
        Screen.MousePointer = vbDefault
        MsgBox "Fehler: " & Err.Number & vbCrLf & _
         "Beschreibung: " & Err.Description & vbCrLf & _
         "Quelle: cfLiqPlan.mWV_JSMessage." & Erl & vbCrLf & Err.Source, _
         vbCritical
End Sub

