VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmLiqPlan"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mCnn As cConnection
Private mDataChanged As Boolean

Private Sub Class_Initialize()
    On Error GoTo Class_Initialize_Error
    Set mCnn = New_c.Connection
    mCnn.CreateNewDB ":memory:"
    Exit Sub
    
Class_Initialize_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.Class_Initialize." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Sub

Public Sub NewLiqPlan()
    On Error GoTo NewLiqPlan_Error
    With mCnn
        .Execute "CREATE TABLE IF NOT EXISTS liqplan (" & _
            "id   INTEGER NOT NULL," & _
            "ben  TEXT(30) NOT NULL DEFAULT ''," & _
            "m1   FLOAT NOT NULL DEFAULT 0," & _
            "m2   FLOAT NOT NULL DEFAULT 0," & _
            "m3   FLOAT NOT NULL DEFAULT 0," & _
            "m4   FLOAT NOT NULL DEFAULT 0," & _
            "m5   FLOAT NOT NULL DEFAULT 0," & _
            "m6   FLOAT NOT NULL DEFAULT 0," & _
            "m7   FLOAT NOT NULL DEFAULT 0," & _
            "m8   FLOAT NOT NULL DEFAULT 0," & _
            "m9   FLOAT NOT NULL DEFAULT 0," & _
            "m10  FLOAT NOT NULL DEFAULT 0," & _
            "m11  FLOAT NOT NULL DEFAULT 0," & _
            "m12  FLOAT NOT NULL DEFAULT 0," & _
            "kat  INTEGER NOT NULL DEFAULT 0," & _
            "dis  INTEGER NOT NULL DEFAULT 0," & _
            "PRIMARY KEY (id))"
        .CreateCommand("INSERT INTO liqplan(id, ben) Values(?,?)").Save "cmdAddPosten"
        .CreateCommand("DELETE FROM liqplan WHERE id=?").Save "cmdDelPosten"
        .CreateCommand("UPDATE liqplan SET ben=? WHERE id=?").Save "cmdUpdatePosten"
        .CreateCommand("UPDATE liqplan SET kat=? WHERE id=?").Save "cmdUpdateKat"
        .CreateCommand("UPDATE liqplan SET dis=? WHERE id=?").Save "cmdUpdateDis"
        .CreateCommand("UPDATE liqplan SET kat=0 WHERE id=?").Save "cmdResKat"
        .Execute "CREATE VIEW getJSONPlan AS SELECT id,m1,m2,m3,m4,m5,m6,m7,m8,m9,m10,m11,m12,liqplan.ben,kat,dis FROM liqplan ORDER BY liqplan.ben DESC"
        .Execute "CREATE VIEW getJSONSum AS SELECT 0 AS m0,SUM(m1) AS m1,SUM(m2) AS m2,SUM(m3) AS m3,SUM(m4) AS m4,SUM(m5) AS m5,SUM(m6) AS m6," & _
                "SUM(m7) AS m7,SUM(m8) AS m8,SUM(m9) AS m9,SUM(m10) AS m10,SUM(m11) AS m11,SUM(m12) AS m12 FROM liqplan WHERE dis=0 UNION " & _
           "SELECT 1 AS m0,ifnull((SELECT SUM(m1) FROM liqplan WHERE m1 > 0 AND dis=0),0) AS m1,ifnull((SELECT SUM(m2) FROM liqplan WHERE m2 > 0 AND dis=0),0) AS m2,ifnull((SELECT SUM(m3) FROM liqplan WHERE m3 > 0 AND dis=0),0) AS m3," & _
                "ifnull((SELECT SUM(m4) FROM liqplan WHERE m4 > 0 AND dis=0),0) AS m4,ifnull((SELECT SUM(m5) FROM liqplan WHERE m5 > 0 AND dis=0),0) AS m5,ifnull((SELECT SUM(m6) FROM liqplan WHERE m6 > 0 AND dis=0),0) AS m6," & _
                "ifnull((SELECT SUM(m7) FROM liqplan WHERE m7 > 0 AND dis=0),0) AS m7,ifnull((SELECT SUM(m8) FROM liqplan WHERE m8 > 0 AND dis=0),0) AS m8,ifnull((SELECT SUM(m9) FROM liqplan WHERE m9 > 0 AND dis=0),0) AS m9," & _
                "ifnull((SELECT SUM(m10) FROM liqplan WHERE m10 > 0 AND dis=0),0) AS m10,ifnull((SELECT SUM(m11) FROM liqplan WHERE m11 > 0 AND dis=0),0) AS m11,ifnull((SELECT SUM(m12) FROM liqplan WHERE m12 > 0 AND dis=0),0) AS m12 UNION " & _
           "SELECT 2 AS m0,ifnull((SELECT SUM(m1) FROM liqplan WHERE m1 < 0 AND dis=0),0) AS m1,ifnull((SELECT SUM(m2) FROM liqplan WHERE m2 < 0 AND dis=0),0) AS m2,ifnull((SELECT SUM(m3) FROM liqplan WHERE m3 < 0 AND dis=0),0) AS m3," & _
                "ifnull((SELECT SUM(m4) FROM liqplan WHERE m4 < 0 AND dis=0),0) AS m4,ifnull((SELECT SUM(m5) FROM liqplan WHERE m5 < 0 AND dis=0),0) AS m5,ifnull((SELECT SUM(m6) FROM liqplan WHERE m6 < 0 AND dis=0),0) AS m6," & _
                "ifnull((SELECT SUM(m7) FROM liqplan WHERE m7 < 0 AND dis=0),0) AS m7,ifnull((SELECT SUM(m8) FROM liqplan WHERE m8 < 0 AND dis=0),0) AS m8,ifnull((SELECT SUM(m9) FROM liqplan WHERE m9 < 0 AND dis=0),0) AS m9," & _
                "ifnull((SELECT SUM(m10) FROM liqplan WHERE m10 < 0 AND dis=0),0) AS m10,ifnull((SELECT SUM(m11) FROM liqplan WHERE m11 < 0 AND dis=0),0) AS m11,ifnull((SELECT SUM(m12) FROM liqplan WHERE m12 < 0 AND dis=0),0) AS m12"
                
        .Execute "CREATE TABLE IF NOT EXISTS liqkat (" & _
            "id   INTEGER NOT NULL," & _
            "kat  TEXT(5) NOT NULL DEFAULT ''," & _
            "ben  TEXT(30) NOT NULL DEFAULT ''," & _
            "PRIMARY KEY (id))"
        .Execute "INSERT INTO liqkat VALUES (0,'DIV','Diverse')"
        .CreateCommand("INSERT INTO liqkat(id, ben) Values(?,?)").Save "cmdAddKat"
        .CreateCommand("DELETE FROM liqkat WHERE id=?").Save "cmdDelKat"
        .CreateCommand("UPDATE liqkat SET kat=? WHERE id=?").Save "cmdUpdateKatKat"
        .CreateCommand("UPDATE liqkat SET ben=? WHERE id=?").Save "cmdUpdateKatBen"
        .Execute "CREATE VIEW getJSONKat AS SELECT id,kat,ben FROM liqkat WHERE id > 0 ORDER BY kat"

        .Execute "CREATE VIEW getJSONKatValues AS SELECT liqkat.kat,liqkat.ben,SUM(m1+m2+m3+m4+m5+m6+m7+m8+m9+m10+m11+m12) AS wert " & _
           "FROM liqplan INNER JOIN liqkat ON liqplan.kat=liqkat.id " & _
           "GROUP BY liqkat.kat,liqkat.ben " & _
           "ORDER BY SUM(m1+m2+m3+m4+m5+m6+m7+m8+m9+m10+m11+m12) DESC"

    End With
    mDataChanged = False
    Exit Sub
    
NewLiqPlan_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.NewLiqPlan." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Sub

Public Function OpenPlan(FileName As String)
    On Error GoTo OpenPlan_Error
    With New_c.Connection(FileName, DBOpenFromFile)
        Set mCnn = .CopyDatabase(":memory:")
    End With
    mDataChanged = False
    OpenPlan = True
    Exit Function
    
OpenPlan_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.OpenPlan." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function DataChanged() As Boolean
    DataChanged = mDataChanged
End Function

Public Function Save(FileName As String) As Boolean
    On Error GoTo Save_Error
    With New_c.fso
        If .FileExists(FileName & "~") Then .DeleteFile FileName & "~"
        mCnn.CopyDatabase FileName & "~", , True
        If .FileExists(FileName & "~") Then
            .MoveFile FileName & "~", FileName, True
            With New_c.Connection(FileName, DBOpenFromFile)
                Set mCnn = .CopyDatabase(":memory:")
                mDataChanged = False
                Save = True
            End With
        End If
    End With
    Exit Function
    
Save_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.Save." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function


'===== CRUD liqplan =====
Public Function GetJSONPlan() As String
    On Error GoTo GetJSONPlan_Error
    GetJSONPlan = New_c.Crypt.UTF8ToVBString(mCnn.OpenRecordset("SELECT * FROM getJSONPlan").ToJSONUTF8)
    Exit Function
    
GetJSONPlan_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.GetJSONPlan." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function GetJSONSum() As String
    On Error GoTo GetJSONSum_Error
    GetJSONSum = New_c.Crypt.UTF8ToVBString(mCnn.OpenRecordset("SELECT * FROM getJSONSum").ToJSONUTF8)
    Exit Function
    
GetJSONSum_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.GetJSONSum." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function


Public Function UpdateData(id As Long, col As String, value As Currency) As Currency
    On Error GoTo UpdateData_Error
    mCnn.ExecCmd "UPDATE liqplan SET " & col & "=? WHERE id=?", value, id
    mDataChanged = True
    UpdateData = mCnn.GetRs("SELECT (m1+m2+m3+m4+m5+m6+m7+m8+m9+m10+m11+m12) AS rsum FROM liqplan WHERE id=" & id)(0)
    Exit Function
    
UpdateData_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.UpdateData." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function AddPosten(Optional Bezeichnung As String = "") As Long
Dim newId As Long
    On Error GoTo AddPosten_Error
    newId = mCnn.GetRs("SELECT MAX(id) FROM liqplan")(0) + 1
    With mCnn.CreateCommand("cmdAddPosten")
        .SetInt32 1, newId
        .SetText 2, Bezeichnung
        .Execute
    End With
    mDataChanged = True
    AddPosten = newId
    Exit Function
    
AddPosten_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.AddPosten." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function DelPosten(delId As Long) As Boolean
    On Error GoTo DelPosten_Error
    With mCnn.CreateCommand("cmdDelPosten")
        .SetInt32 1, delId
        .Execute
    End With
    mDataChanged = True
    DelPosten = True
    Exit Function
    
DelPosten_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.DelPosten." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function UpdateBezeichnung(id As Long, Bezeichnung As String) As Boolean
    On Error GoTo UpdateBezeichnung_Error
    With mCnn.CreateCommand("cmdUpdatePosten")
        .SetInt32 2, id
        .SetText 1, Bezeichnung
        .Execute
    End With
    mDataChanged = True
    UpdateBezeichnung = True
    Exit Function
    
UpdateBezeichnung_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.UpdateBezeichnung." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function UpdateKat(id As Long, Kat As Long) As Boolean
    On Error GoTo UpdateKat_Error
    With mCnn.CreateCommand("cmdUpdateKat")
        .SetInt32 2, id
        .SetInt32 1, Kat
        .Execute
    End With
    mDataChanged = True
    UpdateKat = True
    Exit Function
    
UpdateKat_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.UpdateKat." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

'===== CRUD liqkat =====

Public Function GetJSONKat() As String
    On Error GoTo GetJSONKat_Error
    GetJSONKat = New_c.Crypt.UTF8ToVBString(mCnn.OpenRecordset("SELECT * FROM getJSONKat").ToJSONUTF8)
    Exit Function
    
GetJSONKat_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.GetJSONKat." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function


Public Function AddKat(Optional Bezeichnung As String = "") As Long
Dim newId As Long
    On Error GoTo AddKat_Error
    newId = mCnn.GetRs("SELECT MAX(id) FROM liqkat")(0) + 1
    With mCnn.CreateCommand("cmdAddKat")
        .SetInt32 1, newId
        .SetText 2, Bezeichnung
        .Execute
    End With
    mDataChanged = True
    AddKat = newId
    Exit Function
    
AddKat_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.AddKat." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function DelKat(delId As Long) As Boolean
    On Error GoTo DelKat_Error
    With mCnn
        .BeginTrans
        With .CreateCommand("cmdResKat")
            .SetInt32 1, delId
            .Execute
        End With
        With .CreateCommand("cmdDelKat")
            .SetInt32 1, delId
            .Execute
        End With
        .CommitTrans
    End With
    mDataChanged = True
    DelKat = True
    Exit Function
    
DelKat_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.DelKat." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function UpdateKatKat(id As Long, Kat As String) As Boolean
    On Error GoTo UpdateKatKat_Error
    With mCnn.CreateCommand("cmdUpdateKatKat")
        .SetInt32 2, id
        .SetText 1, Kat
        .Execute
    End With
    mDataChanged = True
    UpdateKatKat = True
    Exit Function
    
UpdateKatKat_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.UpdateKatKat." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

Public Function UpdateKatBen(id As Long, Benennung As String) As Boolean
    On Error GoTo UpdateKatBen_Error
    With mCnn.CreateCommand("cmdUpdateKatBen")
        .SetInt32 2, id
        .SetText 1, Benennung
        .Execute
    End With
    mDataChanged = True
    UpdateKatBen = True
    Exit Function
    
UpdateKatBen_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.UpdateKatBen." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

'===== Auswertungen =====
Public Function GetJSONKatValues() As String
    On Error GoTo GetJSONKat_Error
    GetJSONKatValues = New_c.Crypt.UTF8ToVBString(mCnn.OpenRecordset("SELECT * FROM getJSONKatValues").ToJSONUTF8)
    Exit Function
    
GetJSONKat_Error:
    Err.Raise Err.Number, _
     "cmLiqPlan.GetJSONKat." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

